package org.jk.rag.service.impl;

import org.jk.common.core.utils.MapstructUtils;
import org.jk.common.core.utils.StringUtils;
import org.jk.common.mybatis.core.page.TableDataInfo;
import org.jk.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.jk.rag.domain.ServerBaseInfo;
import org.jk.rag.domain.bo.ServerBaseInfoBo;
import org.jk.rag.domain.vo.ServerBaseInfoVo;
import org.jk.rag.mapper.ServerBaseInfoMapper;
import org.jk.rag.service.IServerBaseInfoService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 服务器基础信息-静态数据Service业务层处理
 *
 * @author Lion Li
 * @date 2026-01-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ServerBaseInfoServiceImpl implements IServerBaseInfoService {

    private final ServerBaseInfoMapper baseMapper;

    /**
     * 查询服务器基础信息-静态数据
     *
     * @param id 主键
     * @return 服务器基础信息-静态数据
     */
    @Override
    public ServerBaseInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询服务器基础信息-静态数据列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 服务器基础信息-静态数据分页列表
     */
    @Override
    public TableDataInfo<ServerBaseInfoVo> queryPageList(ServerBaseInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ServerBaseInfo> lqw = buildQueryWrapper(bo);
        Page<ServerBaseInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的服务器基础信息-静态数据列表
     *
     * @param bo 查询条件
     * @return 服务器基础信息-静态数据列表
     */
    @Override
    public List<ServerBaseInfoVo> queryList(ServerBaseInfoBo bo) {
        LambdaQueryWrapper<ServerBaseInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ServerBaseInfo> buildQueryWrapper(ServerBaseInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ServerBaseInfo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ServerBaseInfo::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getServerIp()), ServerBaseInfo::getServerIp, bo.getServerIp());
        lqw.like(StringUtils.isNotBlank(bo.getServerName()), ServerBaseInfo::getServerName, bo.getServerName());
        lqw.eq(StringUtils.isNotBlank(bo.getServerType()), ServerBaseInfo::getServerType, bo.getServerType());
        lqw.eq(StringUtils.isNotBlank(bo.getOsType()), ServerBaseInfo::getOsType, bo.getOsType());
        lqw.eq(StringUtils.isNotBlank(bo.getOsVersion()), ServerBaseInfo::getOsVersion, bo.getOsVersion());
        return lqw;
    }

    /**
     * 新增服务器基础信息-静态数据
     *
     * @param bo 服务器基础信息-静态数据
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ServerBaseInfoBo bo) {
        ServerBaseInfo add = MapstructUtils.convert(bo, ServerBaseInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改服务器基础信息-静态数据
     *
     * @param bo 服务器基础信息-静态数据
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ServerBaseInfoBo bo) {
        ServerBaseInfo update = MapstructUtils.convert(bo, ServerBaseInfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ServerBaseInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除服务器基础信息-静态数据信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
